com.tibbo.aggregate.common.discovery

## Interface DiscoveryProvider

-     public interface DiscoveryProvider

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configureService(java.lang.String name, boolean enable, DeviceContext deviceContext, DataTable parameters, CallerController callerController)`
    `DeviceContext` | `createDevice(java.lang.String username, java.lang.String deviceName, java.lang.String description, java.lang.String address, CallerController caller)`
    `java.util.List<DiscoverableServiceDefinition>` | `getAvailableServices()`
    `java.lang.String` | `getDescription()`
    `DiscoverableServiceDefinition` | `getDiscoverableServiceDefinition(java.lang.String name)`
    `DataTable` | `getDiscoverySettings(java.lang.String settingsVariable, ContextManager cm, CallerController cc)`
    `java.util.Collection<VariableDefinition>` | `getDiscoverySettingsVariableDefinitions()`
    `java.lang.String` | `getDriver()`
    `java.lang.String` | `getName()`

- - ### Method Detail

    - #### getName

          java.lang.String getName()

    - #### getDescription

          java.lang.String getDescription()

    - #### getDriver

          java.lang.String getDriver()

    - #### getDiscoverySettingsVariableDefinitions

          java.util.Collection<VariableDefinition> getDiscoverySettingsVariableDefinitions()

    - #### getDiscoverySettings

          DataTable getDiscoverySettings(java.lang.String settingsVariable,
                                         ContextManager cm,
                                         CallerController cc)

    - #### getAvailableServices

          java.util.List<DiscoverableServiceDefinition> getAvailableServices()

    - #### createDevice

          DeviceContext createDevice(java.lang.String username,
                                     java.lang.String deviceName,
                                     java.lang.String description,
                                     java.lang.String address,
                                     CallerController caller)
                              throws ContextException

      Throws:
        `ContextException`

    - #### getDiscoverableServiceDefinition

          DiscoverableServiceDefinition getDiscoverableServiceDefinition(java.lang.String name)

    - #### configureService

          void configureService(java.lang.String name,
                                boolean enable,
                                DeviceContext deviceContext,
                                DataTable parameters,
                                CallerController callerController)
                         throws ContextException

      Throws:
        `ContextException`